/* 
 * @(#) $Header: /archive/cvs/cvsroot/diffserv/ns-2/SourceRtg.h,v 1.1 1999/08/06 14:24:46 costa Exp $
 */

#include "config.h"
#include "object.h"
#include "agent.h"
#include "packet.h"

struct hdr_src_rtg { 
	int srcflag_;
	int length_;
	int pointer_;
	u_int32_t *list_;
	static int offset_;
	inline static int& offset() { return offset_; }
	inline static hdr_src_rtg* access(Packet* p) {
		return ((hdr_src_rtg*) p->access(offset_));
	}

	/* per-field member functions */
	int& srcflag() { return (srcflag_); }
	int& length() { return (length_); }
	int& pointer() { return (pointer_); }
	u_int32_t& list_k(int n) { return (list_[n]); }

	//	hdr_src_rtg() : srcflag_(-1), srcid1_(50), srcid2_(50) { }
		hdr_src_rtg() : srcflag_(0), length_(0), pointer_(0) { }
};
