dnl autoconf rules for NS Emulator (NSE)
dnl $Id: configure.in.nse,v 1.2 2000/02/22 21:57:44 salehi Exp $

dnl
dnl Look for ethernet.h
dnl

dnl Now look for supporting structures
dnl

AC_MSG_CHECKING([for struct ether_header])
AC_TRY_COMPILE([
#include <stdio.h>
#include <net/ethernet.h>
], [
int main()
{
	struct ether_header etherHdr;

	return 1;
}
], [
AC_DEFINE(HAVE_ETHER_HEADER_STRUCT)
AC_MSG_RESULT(found)
], [
AC_MSG_RESULT(not found)
])
 

dnl 
dnl Look for ether_addr
dnl
AC_MSG_CHECKING([for struct ether_addr])
AC_TRY_COMPILE([
#include <stdio.h>
#include <net/ethernet.h>
], [
int main()
{
	struct ether_addr etherAddr;

	return 0;
}
], [
AC_DEFINE(HAVE_ETHER_ADDRESS_STRUCT)
AC_MSG_RESULT(found)
], [
AC_MSG_RESULT(not found)
])

cross_compiling=no
dnl
dnl Look for addr2ascii function
dnl
AC_MSG_CHECKING([for addr2ascii()])
AC_TRY_RUN(
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
int main()
{
	char *string;
	struct in_addr addr;

	string = addr2ascii(AF_INET, &addr, sizeof(addr), 0);
	return 0;
}
, [
AC_DEFINE(HAVE_ADDR2ASCII)
AC_MSG_RESULT(found!)
], [
AC_MSG_RESULT(not found!)
],
echo 1
)

dnl
dnl look for SIOCGIFHWADDR
dnl
AC_TRY_RUN(
#include <stdio.h>
#include <sys/ioctl.h>
int main()
{
	int i = SIOCGIFHWADDR;
	return 0;
}
, AC_DEFINE(HAVE_SIOCGIFHWADDR), , echo 1
)
