#include "packet.h"
#include "ip.h"

struct hdr_REU {
	u_int32_t mtype_;			// message type identifier

	static int offset_;
	inline static int& offset() { return offset_; }
	inline static hdr_REU* access(Packet* p) {
		return (hdr_REU*) p->access(offset_);
	}

	// per field member functions
	u_int32_t& message_type() { return mtype_; }
};

class rtProtoREU : public Agent {
public:
	rtProtoREU() : Agent(PT_RTPROTO_REU) { 
		bind("off_REU_", &off_REU_);
	}
	int command(int argc, const char*const* argv);
	void sendpkt(ns_addr_t dst, u_int32_t z, u_int32_t mtype);
	void recv(Packet* p, Handler*);
protected:
	int off_REU_;
};

