#ifndef ns_rtprotodv_h
#define ns_rtprotodv_h

#include "packet.h"
#include "ip.h"

struct hdr_SMM {
	u_int32_t mv_;			// metrics variable identifier

	static int offset_;
	inline static int& offset() { return offset_; }
	inline static hdr_SMM* access(Packet* p) {
		return (hdr_SMM*) p->access(offset_);
	}

	// per field member functions
	u_int32_t& metricsVar() { return mv_; }
};

//por enquanto, pacote DV     luish

class rtProtoSMM : public Agent {
public:
//por enquanto, pacote DV     luish
	rtProtoSMM() : Agent(PT_RTPROTO_SMM) { 
		bind("off_SMM_", &off_SMM_);
	}
	int command(int argc, const char*const* argv);
	void sendpkt(ns_addr_t dst, u_int32_t z, u_int32_t mtvar);
	void recv(Packet* p, Handler*);
protected:
	int off_SMM_;
};

#endif

//luish - arquivo para criar a classe rtProtoSMM
