#Simulator set EnableQoSRt_ 0

#luish: now each link will have three more costs associated with it:
# cost0: propagation delay
# cost1: available bandwidth
# cost2: loss probability

Simulator instproc cost0 {n1 n2 c} {
	$self instvar link_
	$link_([$n1 id]:[$n2 id]) cost0 $c
}

Simulator instproc cost1 {n1 n2 c} {
    $self instvar link_
    $link_([$n1 id]:[$n2 id]) cost1 $c
#    puts stderr "rtobject0: [[$n1 set rtObject_] set link_m1_($n1$n2)]"
    #[$n1 set rtObject_] set link_m1_($n1$n2) $c
#    puts stderr "cost1: $n1 $n2"
#    puts stderr "rtobject1: [[$n1 set rtObject_] set link_m1_($n1$n2)]"
}

Simulator instproc cost2 {n1 n2 c} {
        $self instvar link_
        $link_([$n1 id]:[$n2 id]) cost2 $c
}

# and return the installed objects.
#
Classifier instproc qos-install {slot val CoS} {
     if {$CoS == 0} {
        $self set slots_($slot) $val                      ;#luish:rever!!!
     }
     if {$CoS == 1} {
        $self set slots1_($slot) $val                      ;#luish:rever!!!
     }
     if {$CoS == 2} {
        $self set slots2_($slot) $val                      ;#luish:rever!!!
     }
 
     $self cmd install $slot $val $CoS                      ;#luish: CoS
}

#luish: idem
Classifier instproc qos-installNext {val CoS} {                    ;#luish
        set slot [$self cmd installNext $val $CoS]             ;#luish: CoS
        if {$CoS == 0} {
           $self set slots_($slot) $val                      ;#luish
        }
        if {$CoS == 1} {
           $self set slots1_($slot) $val                      ;#luish
        }
        if {$CoS == 2} {
           $self set slots2_($slot) $val                      ;#luish
        }

        set slot
}

# Default behavior is changed: consider nam as not initialized if 
# no shape OR color parameter is given
Simulator instproc node args {
	$self instvar Node_ routingAgent_ wiredRouting_

puts stderr "Usando meu node"

        if { [Simulator info vars EnableMcast_] != "" } {
                warn "Flag variable Simulator::EnableMcast_ discontinued.\n\t\
                      Use multicast methods as:\n\t\t\
                        % set ns \[new Simulator -multicast on]\n\t\t\
                        % \$ns multicast"
                $self multicast
                Simulator unset EnableMcast_
        }
        if { [Simulator info vars NumberInterfaces_] != "" } {
                warn "Flag variable Simulator::NumberInterfaces_ discontinued.\n\t\
                      Setting (or not) this variable will not affect the simulations."
                Simulator unset NumberInterfaces_
        }
	
	# wireless-ready node

	if [info exists routingAgent_] {
	    if  {[string compare $routingAgent_ ""] != 0} {
	        set node [$self create-wireless-node $args]

		# for base node

		if {[info exists wiredRouting_] && $wiredRouting_ == "ON"} {
		    
		   set Node_([$node id]) $node
		}
	        return $node
	    }
	}

	set node [new [Simulator set node_factory_] $args]

	set Node_([$node id]) $node
	
	$node set ns_ $self

	$node set Multicast 0

	if [$self multicast?] {
	    if { [string compare $args "multicast"] == 0 } {
		$node set Multicast 1
		$node enable-mcast $self
	    }	    
	}
	$self check-node-num
	return $node
}
