#include "agent.h"
#include "rtProto3M.h"       //rever!!!

int hdr_3M::offset_;

static class rt3MHeaderClass : public PacketHeaderClass {
public:
  rt3MHeaderClass() : PacketHeaderClass("PacketHeader/rtProto3M",
					sizeof(hdr_3M)) {
    bind_offset(&hdr_3M::offset_);
  } 
} class_rtProto3M_hdr;

//por enquanto nao estou criando um pacote 3M

static class rtProto3Mclass : public TclClass {
public:
  rtProto3Mclass() : TclClass("Agent/rtProto/3M") {}
  TclObject* create(int, const char*const*) {
    return (new rtProto3M);
  }
} class_rtProto3M;

int rtProto3M::command(int argc, const char*const* argv)
{
  if (strcmp(argv[1], "send-update") == 0) {
    ns_addr_t  dst;
    dst.addr_ = atoi(argv[2]);
    dst.port_ = 0;
    u_int32_t mtvar = atoi(argv[3]);
    u_int32_t size  = atoi(argv[4]);
    sendpkt(dst, mtvar, size);
    return TCL_OK;
  }
  return Agent::command(argc, argv);
}

void rtProto3M::sendpkt(ns_addr_t dst, u_int32_t mtvar, u_int32_t size)
{
  //dst_ = dst;
  daddr() = dst.addr_;
  dport() = dst.port_;                                                    
  size_ = size;
  
  Packet* p = Agent::allocpkt();
  hdr_3M *rh = (hdr_3M*)p->access(off_3M_);     //por enquanto, pacote DV
  rh->metricsVar() = mtvar;
  
  hdr_ip *hip = (hdr_ip*)p->access(off_ip_);
  hip->fid_ = 0x0000FFFF;
  //luish: by now we use this flow id to avoid dropping routing packets
  
  target_->recv(p);
}

void rtProto3M::recv(Packet* p, Handler*)
{
  hdr_3M* rh = (hdr_3M*)p->access(off_3M_);
  hdr_ip* ih = (hdr_ip*)p->access(off_ip_);
  Tcl::instance().evalf("%s recv-update %d %d", name(),
			ih->saddr(), rh->metricsVar());
  Packet::free(p);
}

//luish - arquivo para criar a classe rtProto3M
