#ifndef ns_rtprotodv_h
#define ns_rtprotodv_h

#include "packet.h"
#include "ip.h"

struct hdr_3M {
	u_int32_t mv_;			// metrics variable identifier

	static int offset_;
	inline static int& offset() { return offset_; }
	inline static hdr_3M* access(Packet* p) {
		return (hdr_3M*) p->access(offset_);
	}

	// per field member functions
	u_int32_t& metricsVar() { return mv_; }
};

//por enquanto, pacote DV     luish

class rtProto3M : public Agent {
public:
//por enquanto, pacote DV     luish
	rtProto3M() : Agent(PT_RTPROTO_3M) { 
		bind("off_3M_", &off_3M_);
	}
	int command(int argc, const char*const* argv);
	void sendpkt(ns_addr_t dst, u_int32_t z, u_int32_t mtvar);
	void recv(Packet* p, Handler*);
protected:
	int off_3M_;
};

#endif

//luish - arquivo para criar a classe rtProto3M
