#include "packet.h"
#include "ip.h"

struct hdr_HBH {
	u_int32_t mtype_;			// message type identifier

	static int offset_;
	inline static int& offset() { return offset_; }
	inline static hdr_HBH* access(Packet* p) {
		return (hdr_HBH*) p->access(offset_);
	}

	// per field member functions
	u_int32_t& message_type() { return mtype_; }
};

class rtProtoHBH : public Agent {
public:
	rtProtoHBH() : Agent(PT_RTPROTO_HBH) { 
		bind("off_HBH_", &off_HBH_);
	}
	int command(int argc, const char*const* argv);
	void sendpkt(ns_addr_t dst, u_int32_t z, u_int32_t mtype);
	void recv(Packet* p, Handler*);
protected:
	int off_HBH_;
};

