## 
## File:    usage.gpl (gnuplot script)
## Author:  Pascal ANELLI
## Created: 07/99
## Purpose: plot bandwidth % in function of time
## 
## data files are in local directory

#
#   set environment
#
#set term postscript landscape
#set terminal postscript eps  "Helvetica" 18 
set term x11
#set term latex

#
#   compose plot
#
set data style lines

#set xrange [0:1]
#set yrange [0:1]
set nogrid


set title " average throughtput for a micro flot"
set xlabel  'time'
set ylabel  'bandwidth (%)'

plot "out.data" index 0 title "flow IN (1)" with lines, \
     "out.data" index 1 title "flow OUT (2)" with lines,\
     "out.data" index 2 title "All flow" with lines

pause -1
