#Class Link

#luish: each link now has three additional costs associated with it

# cost 0: propagation delay
Link instproc cost0 c {
    $self instvar cost0_
    set cost0_ $c
}

# cost 1: available bandwidth
Link instproc cost1 c {
    $self instvar cost1_
    set cost1_ $c
}

# cost 2: loss probability
Link instproc cost2 c {
    $self instvar cost2_
    set cost2_ $c
}

Link instproc cost0? {} {
	$self instvar cost0_ link_
	if ![info exists cost0_] {
		set cost0_ [expr [$link_ set delay_] * 1e3]
#	    puts stderr "propagacao: $cost0_"
	}
	set cost0_
}

Link instproc cost2? {} {
	$self instvar cost2_
	if ![info exists cost2_] {
		set cost2_ 1
	}
	set cost2_
}

# cost 1 (available bandwidth) in Mbps
Link instproc cost1? {} {
	$self instvar cost1_ link_
	if ![info exists cost1_] {
		set cost1_ [expr [$link_ set bandwidth_] / 1e6]
#	    puts stderr "banda passante: $cost1_"
	}
	set cost1_
}
