#Node instproc init args {
#    #set args [lreplace $args 0 1]
#    eval $self next $args
#    $self instvar np_ id_ agents_ dmux_ neighbor_ rtsize_ address_
#    $self instvar nodetype_
# 
#    set nodetype_ [[Simulator instance] get-nodetype]                       
#
#    set neighbor_ ""
#    set agents_ ""
#    set dmux_ ""
#    set np_ 0
#    set id_ [Node getid]
#    set rtsize_ 0
#
#        set address_ $args
#        $self set-node-address$nodetype_ $args
#        
#    if [Simulator set EnableQoSRt_] {
#	$self mk-qosr-classifier
#	#puts stderr "QoS Routing..."    ;# luish
#    } else {
#	# default; original behavior!  luish
#	$self mk-default-classifier$nodetype_
#    } 
# 	$self cmd addr $address_; # new by tomh 
#}


Node instproc mk-qosr-classifier {} {
    $self instvar address_ classifier_ id_
    set classifier_ [new Classifier/QoS]
    # set up classifer as a router (default value 8 bit of addr and 8 bit port)
    $classifier_ set mask_ [AddrParams set NodeMask_(1)]
    $classifier_ set shift_ [AddrParams set NodeShift_(1)]
    if ![info exists address_] {
	set address_ $id_
    }
}


Node instproc add-qos-route { dst target CoS } {                        
    $self instvar classifier_ rtsize_
    $classifier_ qos-install $dst $target $CoS                      ;#luish
    #
    # increase the routing table size counter - keeps track of rtg table size
    # for each node
    set rtsize_ [expr $rtsize_ + 1]
}

Node instproc alloc-qos-port { nullagent } {
    $self instvar dmux_ np_
    set p [$dmux_ alloc-port $nullagent 0] ;#luish bacalhau rever!!!
    #isso esta horrivel; tem que ver se o alloc-port deve receber CoS ou nao.
    #esta recebendo, este alloc-port e' do Classifier/QoS!
    if { $np_ < $p } {
	set np_ $p
    }
    if {$np_ > [$dmux_ set mask_] } {
	puts stderr "No of ports($np_) attached to $self node is greater than allowed"
    }
    
    return $p
}


#
# Attach an agent to a node.  Pick a port and
# bind the agent to the port number.
#
# luish
# Mantive o mesmo nome para esta rotina, e fiz as alteracoes necessarias, 
# pois ela e' utilizada em ns-lib.tcl e nao em ns-lib-ext.tcl

#Node instproc attach { agent { port "" } } {
#    $self instvar agents_ address_ dmux_ classifier_
#    $self instvar classifiers_
#    #
#    # assign port number (i.e., this agent receives
#    # traffic addressed to this host and port)
#    #
#    lappend agents_ $agent
#    
#    #
#    # Check if number of agents exceeds length of port-address-field size
#    #
#    set mask [AddrParams set ALL_BITS_SET]
#    set shift 0
#   
#    # The following code is no longer needed.  It is unlikely that
#    # a node holds billions of agents
#    #       if {[expr [llength $agents_] - 1] > $mask} {
#    #               error "\# of agents attached to node $self exceeds port-field length of $mask bits\n"
#    #       }
#   
#
#    #
#    # Attach agents to this node (i.e., the classifier inside).
#    # We call the entry method on ourself to find the front door
#    # (e.g., for multicast the first object is not the unicast
#    #  classifier)
#    # Also, stash the node in the agent and set the
#    # local addr of this agent.
#    #
#    #$agent target [$self entry]
#    $agent set node_ $self
#     
#    if [Simulator set EnableHierRt_] {
#	$agent set agent_addr_ [AddrParams set-hieraddr $address_]
#	
#    } else {
#	$agent set agent_addr_ [expr ($address_ & \
#		[AddrParams set NodeMask_(1)]) \
#		<< [AddrParams set NodeShift_(1) ]]
#    }
#
#   
#    #
#    # If a port demuxer doesn't exist, create it.
#    #
#	
#    if { $dmux_ == "" } {
#	if [Simulator set EnableQoSRt_] {
#	    set dmux_ [new Classifier/QoS]
#	} else {
#	    set dmux_ [new Classifier/Port]              ;#luish - original
#	}
#	$dmux_ set mask_ $mask
#	$dmux_ set shift_ $shift
#	    
#	# $dmux_ set shift_ 0
#	#
#	# point the node's routing entry to itself
#	# at the port demuxer (if there is one)
#	#
#	if [Simulator set EnableHierRt_] {
#	    $self add-hroute $address_ $dmux_
#	} else {
#	    if [Simulator set EnableQoSRt_] {
#		$self add-qos-route $address_ $dmux_ 0 ;#luish: + CoS
#		$self add-qos-route $address_ $dmux_ 1 ;#luish: rever!!!
#		$self add-qos-route $address_ $dmux_ 2 ;#luish: rever!!!
#	    } else {
#		$self add-route $address_ $dmux_   ;#luish: original
#	    }
#	}
#    }
#
#    if {$port == ""} {
#	set ns_ [Simulator instance]
#	$ns_ instvar nullAgent_
#	set port [$self alloc-port $nullAgent_]
#    }
#    $agent set agent_port_ $port
#    
#    $self add-target $agent $port
#
#    set ns_ [Simulator instance]
#    $ns_ instvar nullAgent_
#    if [Simulator set EnableQoSRt_] {
#	set port [$self alloc-qos-port $nullAgent_]
#    } else {
#	set port [$self alloc-port $nullAgent_]          ;#luish: original
#    }
#    $agent set portID_ $port
#
#    if [Simulator set EnableHierRt_] {
#	set nodeaddr [AddrParams set-hieraddr $address_]
#		
#    } else {
#	set nodeaddr [expr ( $address_ &			\
#		[AddrParams set NodeMask_(1)] ) <<	\
#		[AddrParams set NodeShift_(1) ]]
#    }
#    $agent set addr_ [expr (($port & $mask) << $shift) | ( ~($mask << $shift) & $nodeaddr)]
#    
#    if [Simulator set EnableQoSRt_] {      ;# if we have QoS routing...
#        $dmux_ qos-install $port $agent 0  ;#luish CoS  review...
#        $dmux_ qos-install $port $agent 1  ;#luish CoS
#        $dmux_ qos-install $port $agent 2  ;#luish CoS
#    } else {
#        $dmux_ install $port $agent    ;#luish original behavior
#    }
#
#    
#    #TESTING
#    #set addr [$agent set addr_]
#    #     puts "node address: $address_"
#    #     puts "Agent addr: $addr" 
#    
#}

#
# Detach an agent from a node.
#
# luish
# Mantive o mesmo nome para esta rotina, e fiz as alteracoes necessarias, 
# pois ela e' utilizada em ns-lib.tcl e nao em ns-lib-ext.tcl

#Node instproc detach { agent nullagent } {
#    $self instvar agents_ dmux_
#    #
#    # remove agent from list
#    #
#    set k [lsearch -exact $agents_ $agent]
#    if { $k >= 0 } {
#	set agents_ [lreplace $agents_ $k $k]
#    }
#    
#    #
#    # sanity -- clear out any potential linkage
#    #
#    $agent set node_ ""
#    $agent set addr_ 0
#    $agent target $nullagent
#    
#    set port [$agent set portID_]
#	
#    #Install nullagent to sink transit packets   
#    #    $dmux_ clear $port
#
#    if [Simulator set EnableQoSRt_] {
#        $dmux_ qos-install $port $nullagent 0   ;#luish: rever!!! se atachamos
#        $dmux_ qos-install $port $nullagent 1   ;# pros tres CoS, o inverso e'
#        $dmux_ qos-install $port $nullagent 2   ;# verdadeiro...
#    } else {
#        $dmux_ install $port $nullagent     ;# luish: original behavior
#    }
#}

#
# Node support for detailed dynamic routing
#
#Node instproc init-routing rtObject {
#    $self instvar multiPath_ routes_ rtObject_
#    set multiPath_ [$class set multiPath_]
#    if [Simulator set EnableQoSRt_] {
#        set nn [expr ( [$class set nn_] * 8 )]   ;#luish review!!!
#    } else {
#	set nn [$class set nn_]                  ;#luish original behavior
#    }
#    for {set i 0} {$i < $nn} {incr i} {
#	set routes_($i) 0
#    }
#    if ![info exists rtObject_] {
#	$self set rtObject_ $rtObject
#    }
#    $self set rtObject_
#}

#
# Node support for equal cost multi path routing
#
Node instproc add-qos-routes {id ifs CoS} {                          
    $self instvar classifier_ multiPath_ routes_ mpathClsfr_
    if !$multiPath_ {
	if {[llength $ifs] > 1} {
	    warn "$class::$proc cannot install multiple routes"
	    set ifs [lindex $ifs 0]
	}
	$self add-qos-route $id [$ifs head] $CoS              ;#luish
	set routes_($id) 1
	return
    }
    if {$routes_($id) <= 0 && [llength $ifs] == 1 && 	\
	    ![info exists mpathClsfr_($id)]} {
	$self add-qos-route $id [$ifs head] $CoS              ;#luish
	set routes_($id) 1
    } else {
	if ![info exists mpathClsfr_($id)] {
	    # 1. get new MultiPathClassifier,
	    # 2. migrate existing routes to that mclassifier
	    # 3. install the mclassifier in the node classifier_
	    #
            set mpathClsfr_($id) [new Classifier/MultiPath]
            if {$routes_($id) > 0} {
		assert {$routes_($id) == 1}
		$mpathClsfr_($id) qos-installNext [$classifier_ in-slot? $id] $CoS ;#luish
            }
            $classifier_ qos-install $id $mpathClsfr_($id) $CoS        ;#luish
	}
        foreach L $ifs {
	    $mpathClsfr_($id) qos-installNext [$L head] $CoS       ;#luish
	    incr routes_($id)
        }
    }
}

#luish: we have a fourth argument, Class of Service (CoS)
Node instproc delete-qos-routes {id ifs nullagent CoS} {       
    $self instvar mpathClsfr_ routes_
    if [info exists mpathClsfr_($id)] {
	foreach L $ifs {
	    set nonLink([$L head]) 1
	}
	foreach {slot link} [$mpathClsfr_($id) adjacents] {
	    if [info exists nonLink($link)] {
		$mpathClsfr_($id) clear $slot $CoS    ;#luish
		incr routes_($id) -1
	    }
	}
    } else {
	$self add-qos-route $id $nullagent $CoS               ;#luish + CoS
	incr routes_($id) -1
    }
}

Node instproc entry-New {} {

        if [info exists router_supp_] {
                return $router_supp_
        }
        if ![info exist ns_] {
                set ns_ [Simulator instance]
        }
        if [$ns_ multicast?] {
	    if { [ $self set Multicast] } {
                $self instvar switch_
                return $switch_
	    }
        }
        $self instvar classifier_
        return $classifier_
}